using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Shared;

namespace NewStefanoClipping2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void OnFormLoad(object sender, EventArgs e)
        {
        }
        
        private void PrintWithNewSyncFusion()
        {
            PdfDocument doc = new PdfDocument();
            doc.FileStructure.CrossReferenceType = PdfCrossReferenceType.CrossReferenceTable;
            doc.FileStructure.Version = PdfVersion.Version1_4;

            PdfPage page = doc.Pages.Add();

            PdfStringFormat format = new PdfStringFormat();
            //To avoid text wrapping and clipping
            format.WordWrap = PdfWordWrapType.None;
            format.LineAlignment = PdfVerticalAlignment.Middle;

            PdfTextElement element = new PdfTextElement();
            element.Font = new PdfStandardFont(PdfFontFamily.Helvetica, 12);
            element.Text = "StefanoClippingSampleWithoutSpaces";
            element.StringFormat = format;

            //PdfSolidBrush brush = new PdfSolidBrush(Color.Black);

            for (int i = 10; i > 0; i--)
            {
                Rectangle rect1 = new Rectangle(0, 5 + 37 * (10 - i), 27 * i, 35);
                PdfRectangle pdfRect1 = new PdfRectangle(rect1);
                pdfRect1.Draw(page, 0, 0);

                // I try also using SetClip method but the result is the same!

                //PdfGraphicsState s = page.Graphics.Save();
                //page.Graphics.SetClip(rect1);
                //page.Graphics.DrawString(element.Text, element.Font, brush, rect1, element.StringFormat);
                //page.Graphics.Restore(s);
                PdfTextLayoutResult result = (PdfTextLayoutResult)element.Draw(page, rect1);

                if (!String.IsNullOrEmpty(result.Remainder))
                {
                    rect1.X += rect1.Width + 5;
                    rect1.Width = 200;
                    element.Text = "--> The text is not clipped!";
                    element.Draw(page, rect1);

                    element.Text = "StefanoClippingSampleWithoutSpaces";
                }
            }

            doc.Save("NewSyncFusion.pdf");
            System.Diagnostics.Process.Start("NewSyncFusion.pdf");
        }

        private void PrintWithOldSyncFusion()
        {
            Syncfusion.Pdf.PDFDocument doc = new Syncfusion.Pdf.PDFDocument();
            doc.FileFormat = FileFormat.Format1_4;

            for (int i = 10; i > 0; i--)
            {
                Rectangle rect1 = new Rectangle(0, 5 + 37 * (10 - i), 27 * i, 35);

                Font font = new Font("Helvetica", 12);
                IPDFFont pdfFont = doc.Fonts.Add(font);

                IPDFGraphicState graphicState = doc.LastPage.Graphics.CreateGraphicState();



                doc.LastPage.Graphics.DrawRectangle(rect1);
                doc.LastPage.Graphics.DrawText(rect1.Location, "StefanoClippingSampleWithoutSpaces", pdfFont, graphicState, rect1);

                //pdfrectangle pdfrect1 = new pdfrectangle(rect1);
                //pdfrect1.draw(page, 0, 0);
                //pdftextlayoutresult result = (pdftextlayoutresult)element.draw(page, rect1);

                //if (!string.isnullorempty(result.remainder))
                //{
                //    rect1.x += rect1.width + 5;
                //    rect1.width = 200;
                //    element.text = "--> the text is not clipped!";
                //    element.draw(page, rect1);

                //    element.text = "stefanoclippingsamplewithoutspaces";
                //}
            }
            doc.Save("OldSyncFusion.pdf");
            System.Diagnostics.Process.Start("OldSyncFusion.pdf");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PrintWithNewSyncFusion();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            PrintWithOldSyncFusion();

        }
    }
}